=== modified file '.quickly'
--- .quickly	2010-12-15 18:49:42 +0000
+++ .quickly	2010-12-23 19:04:36 +0000
@@ -2,4 +2,4 @@
 version = 0.4.2
 template = pandora-build
 project-type = application
-pandora-version = 0.163
+pandora-version = 0.167

=== modified file 'm4/pandora_canonical.m4'
--- m4/pandora_canonical.m4	2010-12-19 16:20:13 +0000
+++ m4/pandora_canonical.m4	2010-12-23 19:04:36 +0000
@@ -4,7 +4,7 @@
 dnl with or without modifications, as long as this notice is preserved.
 
 dnl Which version of the canonical setup we're using
-AC_DEFUN([PANDORA_CANONICAL_VERSION],[0.163])
+AC_DEFUN([PANDORA_CANONICAL_VERSION],[0.167])
 
 AC_DEFUN([PANDORA_FORCE_DEPEND_TRACKING],[
   AC_ARG_ENABLE([fat-binaries],
@@ -38,6 +38,7 @@
   m4_define([PCT_REQUIRE_CXX],[no])
   m4_define([PCT_FORCE_GCC42],[no])
   m4_define([PCT_DONT_SUPPRESS_INCLUDE],[no])
+  m4_define([PCT_NO_VC_CHANGELOG],[no])
   m4_define([PCT_VERSION_FROM_VC],[no])
   m4_define([PCT_USE_VISIBILITY],[yes])
   m4_foreach([pct_arg],[$*],[
@@ -58,6 +59,10 @@
         m4_undefine([PCT_DONT_SUPPRESS_INCLUDE])
         m4_define([PCT_DONT_SUPPRESS_INCLUDE],[yes])
       ],
+      [no-vc-changelog], [
+        m4_undefine([PCT_NO_VC_CHANGELOG])
+        m4_define([PCT_NO_VC_CHANGELOG],[yes])
+      ],
       [version-from-vc], [
         m4_undefine([PCT_VERSION_FROM_VC])
         m4_define([PCT_VERSION_FROM_VC],[yes])
@@ -104,6 +109,11 @@
   ])
   AC_REQUIRE([PANDORA_64BIT])
 
+  m4_if(PCT_NO_VC_CHANGELOG,yes,[
+    vc_changelog=no
+  ],[
+    vc_changelog=yes
+  ])
   m4_if(PCT_VERSION_FROM_VC,yes,[
     PANDORA_VC_VERSION
   ],[
@@ -244,12 +254,10 @@
 
   PANDORA_HAVE_GCC_ATOMICS
 
-  save_CFLAGS="${CFLAGS}"
-  CFLAGS="${CFLAGS} -Werror"
-  PANDORA_CHECK_VISIBILITY
-  CFLAGS="${save_CFLAGS}"
   m4_if(PCT_USE_VISIBILITY,[yes],[
     PANDORA_ENABLE_VISIBILITY
+    ],[
+    PANDORA_CHECK_VISIBILITY
   ])
 
   PANDORA_HEADER_ASSERT
@@ -347,6 +355,7 @@
 #endif
 
 #if !defined(HAVE_ULONG) && !defined(__USE_MISC)
+# define HAVE_ULONG 1
 typedef unsigned long int ulong;
 #endif
 

=== renamed file 'm4/ac_cxx_compile_stdcxx_0x.m4' => 'm4/pandora_compile_stdcxx_0x.m4'
=== renamed file 'm4/ac_cxx_header_stdcxx_98.m4' => 'm4/pandora_header_stdcxx_98.m4'
=== modified file 'm4/pandora_vc_build.m4'
--- m4/pandora_vc_build.m4	2010-12-18 04:43:40 +0000
+++ m4/pandora_vc_build.m4	2010-12-23 18:39:39 +0000
@@ -53,7 +53,9 @@
         PANDORA_VC_REVNO="${PANDORA_BZR_REVNO}"
         PANDORA_VC_REVID=`bzr log -r-1 --show-ids | grep revision-id | cut -f2 -d' ' | head -1`
         PANDORA_VC_BRANCH=`bzr nick`
-	bzr log --gnu > ChangeLog
+        if test "x${vcs_changelog}" = "xyes"; then
+          bzr log --gnu > ChangeLog
+        fi
       fi
     fi
 

=== modified file 'm4/pandora_visibility.m4'
--- m4/pandora_visibility.m4	2010-08-21 03:34:31 +0000
+++ m4/pandora_visibility.m4	2010-12-17 18:04:56 +0000
@@ -23,14 +23,13 @@
 AC_DEFUN([PANDORA_CHECK_VISIBILITY],
 [
   AC_REQUIRE([AC_PROG_CC])
-  AC_REQUIRE([PANDORA_PLATFORM])
   CFLAG_VISIBILITY=
   HAVE_VISIBILITY=0
   AS_IF([test -n "$GCC"],[
     AC_MSG_CHECKING([for simple visibility declarations])
     AC_CACHE_VAL([gl_cv_cc_visibility], [
       gl_save_CFLAGS="$CFLAGS"
-      CFLAGS="$CFLAGS -fvisibility=hidden"
+      CFLAGS="$CFLAGS -fvisibility=hidden -Werror"
       AC_TRY_COMPILE(
         [extern __attribute__((__visibility__("hidden"))) int hiddenvar;
          extern __attribute__((__visibility__("default"))) int exportedvar;

=== modified file 'm4/pandora_warnings.m4'
--- m4/pandora_warnings.m4	2010-12-26 00:22:34 +0000
+++ m4/pandora_warnings.m4	2010-12-26 21:08:54 +0000
@@ -372,7 +372,7 @@
       PROTOSKIP_WARNINGS="-Wno-effc++ -Wno-shadow -Wno-missing-braces ${NO_ATTRIBUTES}"
       NO_WERROR="-Wno-error"
       INNOBASE_SKIP_WARNINGS="-Wno-shadow -Wno-cast-align"
-      PERMISSIVE_WARNINGS="-Wno-error -fpermissive"
+      PERMISSIVE_WARNINGS="-Wno-error"
       AS_IF([test "$host_vendor" = "apple"],[
         BOOSTSKIP_WARNINGS="-Wno-uninitialized"
       ])

=== modified file 'plugin/innobase/dict/dict0dict.cc'
--- plugin/innobase/dict/dict0dict.cc	2010-12-26 01:32:11 +0000
+++ plugin/innobase/dict/dict0dict.cc	2010-12-26 21:08:54 +0000
@@ -2862,13 +2862,13 @@
 		*id = dst = static_cast<char *>(mem_heap_alloc(heap, len));
 
 		innobase_convert_from_id(cs, dst, str, len);
-	} else if (!strncmp(str, srv_mysql50_table_name_prefix,
-			    sizeof srv_mysql50_table_name_prefix)) {
+	} else if (!strncmp(str, srv_mysql50_table_name_prefix.c_str(),
+			    srv_mysql50_table_name_prefix.size())) {
 		/* This is a pre-5.1 table name
 		containing chars other than [A-Za-z0-9].
 		Discard the prefix and use raw UTF-8 encoding. */
-		str += sizeof srv_mysql50_table_name_prefix;
-		len -= sizeof srv_mysql50_table_name_prefix;
+		str += srv_mysql50_table_name_prefix.size();
+		len -= srv_mysql50_table_name_prefix.size();
 		goto convert_id;
 	} else {
 		/* Encode using filename-safe characters. */

=== modified file 'plugin/innobase/ha/ha0storage.cc'
--- plugin/innobase/ha/ha0storage.cc	2010-12-26 00:22:34 +0000
+++ plugin/innobase/ha/ha0storage.cc	2010-12-26 21:08:54 +0000
@@ -35,6 +35,8 @@
 #include "ha0storage.ic"
 #endif
 
+#include <cassert>
+
 /*******************************************************************//**
 Retrieves a data from a storage. If it is present, a pointer to the
 stored copy of data is returned, otherwise NULL is returned. */
@@ -62,7 +64,7 @@
 		fold,			/* key */
 		ha_storage_node_t*,	/* type of node->next */
 		node,			/* auxiliary variable */
-		,			/* assertion */
+                assert(true),			/* assertion */
 		IS_FOUND);		/* search criteria */
 
 	if (node == NULL) {

=== modified file 'plugin/innobase/handler/ha_innodb.cc'
--- plugin/innobase/handler/ha_innodb.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/handler/ha_innodb.cc	2010-12-26 21:08:54 +0000
@@ -71,6 +71,7 @@
 
 #include <boost/algorithm/string.hpp>
 #include <boost/program_options.hpp>
+#include <boost/scoped_array.hpp>
 #include <boost/filesystem.hpp>
 #include <drizzled/module/option_map.h>
 #include <iostream>
@@ -1670,7 +1671,8 @@
         FALSE=id is an UTF-8 string */
 {
   char nz[NAME_LEN + 1];
-  char nz2[NAME_LEN + 1 + sizeof srv_mysql50_table_name_prefix];
+  const size_t nz2_size= NAME_LEN + 1 + srv_mysql50_table_name_prefix.size();
+  boost::scoped_array<char> nz2(new char[nz2_size]);
 
   const char* s = id;
   int   q;
@@ -1687,8 +1689,8 @@
     memcpy(nz, id, idlen);
     nz[idlen] = 0;
 
-    s = nz2;
-    idlen = TableIdentifier::filename_to_tablename(nz, nz2, sizeof nz2);
+    s = nz2.get();
+    idlen = TableIdentifier::filename_to_tablename(nz, nz2.get(), nz2_size);
   }
 
   /* See if the identifier needs to be quoted. */
@@ -2101,16 +2103,17 @@
 
 #ifdef UNIV_DEBUG
   static const char test_filename[] = "-@";
-  char      test_tablename[sizeof test_filename
-    + sizeof srv_mysql50_table_name_prefix];
-  if ((sizeof test_tablename) - 1
-      != filename_to_tablename(test_filename, test_tablename,
-                               sizeof test_tablename)
-      || strncmp(test_tablename,
-                 srv_mysql50_table_name_prefix,
-                 sizeof srv_mysql50_table_name_prefix)
-      || strcmp(test_tablename
-                + sizeof srv_mysql50_table_name_prefix,
+  const size_t test_tablename_size= sizeof test_filename
+    + srv_mysql50_table_name_prefix.size();
+  boost::scoped_array test_tablename(new char[test_tablename_size]);
+  if ((test_tablename_size) - 1
+      != filename_to_tablename(test_filename, test_tablename.get(),
+                               test_tablename_size)
+      || strncmp(test_tablename.get(),
+                 srv_mysql50_table_name_prefix.c_str(),
+                 srv_mysql50_table_name_prefix.size())
+      || strcmp(test_tablename.get()
+                + srv_mysql50_table_name_prefix.size(),
                 test_filename)) {
     errmsg_printf(ERRMSG_LVL_ERROR, "tablename encoding has been changed");
     goto error;

=== modified file 'plugin/innobase/include/srv0srv.h'
--- plugin/innobase/include/srv0srv.h	2010-12-20 04:10:53 +0000
+++ plugin/innobase/include/srv0srv.h	2010-12-26 21:08:54 +0000
@@ -48,10 +48,15 @@
 #include "que0types.h"
 #include "trx0types.h"
 
+#include <string>
+
 extern const char*	srv_main_thread_op_info;
 
 /** Prefix used by MySQL to indicate pre-5.1 table name encoding */
-extern const char	srv_mysql50_table_name_prefix[9];
+/** LOOKIE HERE!!!! This used to be srv_mysql50_table_name_prefix[10]
+    which was a buffer overrun, because it didn't allow for the trailing
+    '\0'. Thanks C++! */
+static const std::string srv_mysql50_table_name_prefix("#mysql50#");
 
 /* When this event is set the lock timeout and InnoDB monitor
 thread starts running */

=== modified file 'plugin/innobase/include/ut0lst.h'
--- plugin/innobase/include/ut0lst.h	2010-12-18 04:43:40 +0000
+++ plugin/innobase/include/ut0lst.h	2010-12-26 21:08:54 +0000
@@ -39,12 +39,15 @@
 to both ends of the list and a count of nodes in the list (excluding
 the base node from the count).
 @param TYPE	the name of the list node data type */
-#define UT_LIST_BASE_NODE_T(TYPE)\
-struct {\
-	ulint	count;	/*!< count of nodes in list */\
-	TYPE *	start;	/*!< pointer to list start, NULL if empty */\
-	TYPE *	end;	/*!< pointer to list end, NULL if empty */\
-}\
+template<class T>
+class ut_list_base_node
+{
+public:
+  size_t count;	/*!< count of nodes in list */\
+  T *	start;	/*!< pointer to list start, NULL if empty */\
+  T *	end;	/*!< pointer to list end, NULL if empty */\
+};
+#define UT_LIST_BASE_NODE_T(TYPE) ut_list_base_node<TYPE>
 
 /*******************************************************************//**
 This macro expands to the unnamed type definition of a struct which

=== modified file 'plugin/innobase/row/row0merge.cc'
--- plugin/innobase/row/row0merge.cc	2010-12-26 15:48:26 +0000
+++ plugin/innobase/row/row0merge.cc	2010-12-26 21:08:54 +0000
@@ -191,7 +191,7 @@
 	buf->heap = heap;
 	buf->index = index;
 	buf->max_tuples = max_tuples;
-	buf->tuples = static_cast<dfield_t **>(mem_heap_alloc(heap,
+	buf->tuples = static_cast<const dfield_t **>(mem_heap_alloc(heap,
 				     2 * max_tuples * sizeof *buf->tuples));
 	buf->tmp_tuples = buf->tuples + max_tuples;
 
@@ -650,7 +650,7 @@
 	mem_heap_t*	heap	= mem_heap_create(2 * i * sizeof **offsets1
 						  + 3 * sizeof **buf);
 
-	*buf = static_cast<mrec_buf_t**>(mem_heap_alloc(heap, 3 * sizeof **buf));
+	*buf = static_cast<mrec_buf_t*>(mem_heap_alloc(heap, 3 * sizeof **buf));
 	*offsets1 = static_cast<ulint*>(mem_heap_alloc(heap, i * sizeof **offsets1));
 	*offsets2 = static_cast<ulint*>(mem_heap_alloc(heap, i * sizeof **offsets2));
 
@@ -1165,7 +1165,7 @@
 
 	/* Create and initialize memory for record buffers */
 
-	merge_buf = static_cast<row_merge_buf_t *>(mem_alloc(n_index * sizeof *merge_buf));
+	merge_buf = static_cast<row_merge_buf_t **>(mem_alloc(n_index * sizeof *merge_buf));
 
 	for (i = 0; i < n_index; i++) {
 		merge_buf[i] = row_merge_buf_create(index[i]);
@@ -2639,7 +2639,7 @@
 
 	merge_files = static_cast<merge_file_t *>(mem_alloc(n_indexes * sizeof *merge_files));
 	block_size = 3 * sizeof *block;
-	block = static_cast<byte *>(os_mem_alloc_large(&block_size));
+	block = static_cast<row_merge_block_t *>(os_mem_alloc_large(&block_size));
 
 	for (i = 0; i < n_indexes; i++) {
 

=== modified file 'plugin/innobase/row/row0sel.cc'
--- plugin/innobase/row/row0sel.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/row/row0sel.cc	2010-12-26 21:08:54 +0000
@@ -258,7 +258,7 @@
 {
 	sel_node_t*	node;
 
-	node = mem_heap_alloc(heap, sizeof(sel_node_t));
+        node = static_cast<sel_node_t *>(mem_heap_alloc(heap, sizeof(sel_node_t)));
 	node->common.type = QUE_NODE_SELECT;
 	node->state = SEL_NODE_OPEN;
 
@@ -338,7 +338,7 @@
 		eval_node_copy_val(var->alias, exp);
 
 		exp = que_node_get_next(exp);
-		var = que_node_get_next(var);
+                var = static_cast<sym_node_t *>(que_node_get_next(var));
 	}
 }
 
@@ -355,12 +355,12 @@
 
 	ut_ad(node->is_aggregate);
 
-	func_node = node->select_list;
+        func_node = static_cast<func_node_t *>(node->select_list);
 
 	while (func_node) {
 		eval_node_set_int_val(func_node, 0);
 
-		func_node = que_node_get_next(func_node);
+                func_node = static_cast<func_node_t *>(que_node_get_next(func_node));
 	}
 
 	node->aggregate_already_fetched = FALSE;
@@ -486,8 +486,8 @@
 
 	ut_ad(que_node_get_type(column) == QUE_NODE_SYMBOL);
 
-	column->prefetch_buf = mem_alloc(SEL_MAX_N_PREFETCH
-					 * sizeof(sel_buf_t));
+        column->prefetch_buf = static_cast<sel_buf_t *>(mem_alloc(SEL_MAX_N_PREFETCH
+                                                                  * sizeof(sel_buf_t)));
 	for (i = 0; i < SEL_MAX_N_PREFETCH; i++) {
 		sel_buf = column->prefetch_buf + i;
 
@@ -566,7 +566,7 @@
 		column values to be able to free it later: therefore
 		we swap the values for sel_buf and val */
 
-		sel_buf->data = dfield_get_data(val);
+                sel_buf->data = static_cast<byte *>(dfield_get_data(val));
 		sel_buf->len = dfield_get_len(val);
 		sel_buf->val_buf_size = que_node_get_val_buf_size(column);
 
@@ -634,7 +634,7 @@
 
 		val = que_node_get_val(column);
 
-		data = dfield_get_data(val);
+                data = static_cast<byte *>(dfield_get_data(val));
 		len = dfield_get_len(val);
 		val_buf_size = que_node_get_val_buf_size(column);
 
@@ -746,7 +746,7 @@
 		/* Evaluate the left side of the comparison, i.e., get the
 		column value if there is an indirection */
 
-		eval_sym(cond->args);
+          eval_sym(static_cast<sym_node_t *>(cond->args));
 
 		/* Do the comparison */
 
@@ -882,7 +882,7 @@
 		err = lock_clust_rec_read_check_and_lock(
 			0, btr_pcur_get_block(&plan->clust_pcur),
 			clust_rec, index, offsets,
-			node->row_lock_mode, lock_type, thr);
+                        static_cast<lock_mode>(node->row_lock_mode), lock_type, thr);
 
 		switch (err) {
 		case DB_SUCCESS:
@@ -989,11 +989,11 @@
 	}
 
 	if (dict_index_is_clust(index)) {
-		err = lock_clust_rec_read_check_and_lock(
-			0, block, rec, index, offsets, mode, type, thr);
+		err = lock_clust_rec_read_check_and_lock(0, block, rec, index,
+                                                         offsets, static_cast<lock_mode>(mode), type, thr);
 	} else {
-		err = lock_sec_rec_read_check_and_lock(
-			0, block, rec, index, offsets, mode, type, thr);
+		err = lock_sec_rec_read_check_and_lock(0, block, rec, index,
+                                                       offsets, static_cast<lock_mode>(mode), type, thr);
 	}
 
 	return(err);
@@ -2023,7 +2023,7 @@
 
 	ut_ad(thr);
 
-	node = thr->run_node;
+        node = static_cast<sel_node_t *>(thr->run_node);
 
 	ut_ad(que_node_get_type(node) == QUE_NODE_SELECT);
 
@@ -2060,14 +2060,14 @@
 
 			while (table_node) {
 				err = lock_table(0, table_node->table,
-						 i_lock_mode, thr);
+                                                 static_cast<lock_mode>(i_lock_mode), thr);
 				if (err != DB_SUCCESS) {
 					thr_get_trx(thr)->error_state = err;
 
 					return(NULL);
 				}
 
-				table_node = que_node_get_next(table_node);
+                                table_node = static_cast<sym_node_t *>(que_node_get_next(table_node));
 			}
 		}
 
@@ -2124,7 +2124,7 @@
 
 	ut_ad(thr);
 
-	node = thr->run_node;
+        node = static_cast<fetch_node_t *>(thr->run_node);
 	sel_node = node->cursor_def;
 
 	ut_ad(que_node_get_type(node) == QUE_NODE_FETCH);
@@ -2183,7 +2183,7 @@
 	void*	row,		/*!< in:  sel_node_t* */
 	void*	user_arg)	/*!< in:  not used */
 {
-	sel_node_t*	node = row;
+        sel_node_t *node = static_cast<sel_node_t *>(row);
 	que_node_t*	exp;
 	ulint		i = 0;
 
@@ -2232,7 +2232,7 @@
 
 	ut_ad(thr);
 
-	node = thr->run_node;
+        node = static_cast<row_printf_node_t *>(thr->run_node);
 
 	sel_node = node->sel_node;
 
@@ -2801,9 +2801,9 @@
 						UNIV_PAGE_SIZE);
 				}
 
-				data = memcpy(mem_heap_alloc(
+                                data = static_cast<byte *>(memcpy(mem_heap_alloc(
 						prebuilt->blob_heap, len),
-						data, len);
+                                                                  data, len));
 			}
 		}
 
@@ -2985,7 +2985,8 @@
 		err = lock_clust_rec_read_check_and_lock(
 			0, btr_pcur_get_block(prebuilt->clust_pcur),
 			clust_rec, clust_index, *offsets,
-			prebuilt->select_lock_type, LOCK_REC_NOT_GAP, thr);
+                        static_cast<lock_mode>(prebuilt->select_lock_type),
+                        LOCK_REC_NOT_GAP, thr);
 		switch (err) {
 		case DB_SUCCESS:
 		case DB_SUCCESS_LOCKED_REC:
@@ -3009,10 +3010,10 @@
 
 			/* The following call returns 'offsets' associated with
 			'old_vers' */
-			err = row_sel_build_prev_vers_for_mysql(
+                  err = static_cast<db_err>(row_sel_build_prev_vers_for_mysql(
 				trx->read_view, clust_index, prebuilt,
 				clust_rec, offsets, offset_heap, &old_vers,
-				mtr);
+                                mtr));
 
 			if (err != DB_SUCCESS || old_vers == NULL) {
 
@@ -3233,7 +3234,7 @@
 			buffers in Linux. Put magic numbers there to help
 			to track a possible bug. */
 
-			buf = mem_alloc(prebuilt->mysql_row_len + 8);
+                        buf = static_cast<byte *>(mem_alloc(prebuilt->mysql_row_len + 8));
 
 			prebuilt->fetch_cache[i] = buf + 4;
 

=== modified file 'plugin/innobase/row/row0upd.cc'
--- plugin/innobase/row/row0upd.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/row/row0upd.cc	2010-12-26 21:08:54 +0000
@@ -313,7 +313,7 @@
 {
 	upd_node_t*	node;
 
-	node = mem_heap_alloc(heap, sizeof(upd_node_t));
+        node = static_cast<upd_node_t *>(mem_heap_alloc(heap, sizeof(upd_node_t)));
 	node->common.type = QUE_NODE_UPDATE;
 
 	node->state = UPD_NODE_UPDATE_CLUSTERED;
@@ -398,7 +398,7 @@
 	pos = dict_index_get_sys_col_pos(index, type);
 
 	dfield = dtuple_get_nth_field(entry, pos);
-	field = dfield_get_data(dfield);
+        field = static_cast<byte *>(dfield_get_data(dfield));
 
 	if (type == DATA_TRX_ID) {
 		trx_write_trx_id(field, val);
@@ -648,7 +648,7 @@
 				mlog_close(mtr, log_ptr);
 
 				mlog_catenate_string(mtr,
-						     dfield_get_data(new_val),
+                                                     static_cast<byte *>(dfield_get_data(new_val)),
 						     len);
 
 				log_ptr = mlog_open(mtr, MLOG_BUF_MARGIN);
@@ -907,7 +907,7 @@
 					out: fetched length of the prefix */
 	mem_heap_t*	heap)		/*!< in: heap where to allocate */
 {
-	byte*	buf = mem_heap_alloc(heap, *len);
+        byte* buf = static_cast<byte *>(mem_heap_alloc(heap, *len));
 
 	*len = btr_copy_externally_stored_field_prefix(buf, *len,
 						       zip_size,
@@ -945,7 +945,7 @@
 	}
 
 	len = dfield_get_len(dfield);
-	data = dfield_get_data(dfield);
+        data = static_cast<const byte *>(dfield_get_data(dfield));
 
 	if (field->prefix_len > 0) {
 		ibool		fetch_ext = dfield_is_ext(dfield)
@@ -996,7 +996,7 @@
 		stored part of the column.  The data
 		will have to be copied. */
 		ut_a(uf->orig_len > BTR_EXTERN_FIELD_REF_SIZE);
-		buf = mem_heap_alloc(heap, uf->orig_len);
+                buf = static_cast<byte *>(mem_heap_alloc(heap, uf->orig_len));
 		/* Copy the locally stored prefix. */
 		memcpy(buf, data,
 		       uf->orig_len - BTR_EXTERN_FIELD_REF_SIZE);
@@ -1146,7 +1146,7 @@
 	table = index->table;
 	ut_ad(n_cols == dict_table_get_n_cols(table));
 
-	ext_cols = mem_heap_alloc(heap, n_cols * sizeof *ext_cols);
+        ext_cols = static_cast<ulint *>(mem_heap_alloc(heap, n_cols * sizeof *ext_cols));
 	n_ext_cols = 0;
 
 	dtuple_set_info_bits(row, update->info_bits);
@@ -2154,7 +2154,7 @@
 
 	trx_start_if_not_started(trx);
 
-	node = thr->run_node;
+        node = static_cast<upd_node_t *>(thr->run_node);
 
 	sel_node = node->select;
 

=== modified file 'plugin/innobase/srv/srv0srv.cc'
--- plugin/innobase/srv/srv0srv.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/srv/srv0srv.cc	2010-12-26 21:08:54 +0000
@@ -106,9 +106,6 @@
 
 UNIV_INTERN const char*	srv_main_thread_op_info = "";
 
-/** Prefix used by MySQL to indicate pre-5.1 table name encoding */
-UNIV_INTERN const char	srv_mysql50_table_name_prefix[9] = "#mysql50#";
-
 /* Server parameters which are read from the initfile */
 
 /* The following three are dir paths which are catenated before file
@@ -910,7 +907,7 @@
 
 	slot = srv_table_get_nth_slot(slot_no);
 
-	type = slot->type;
+        type = static_cast<srv_thread_type>(slot->type);
 
 	ut_ad(type >= SRV_WORKER);
 	ut_ad(type <= SRV_MASTER);
@@ -953,7 +950,9 @@
 
 		slot = srv_table_get_nth_slot(i);
 
-		if (slot->in_use && slot->type == type && slot->suspended) {
+                if (slot->in_use &&
+                    (static_cast<srv_thread_type>(slot->type) == type) &&
+                    slot->suspended) {
 
 			slot->suspended = FALSE;
 
@@ -998,7 +997,7 @@
 
 	slot = srv_table_get_nth_slot(slot_no);
 
-	type = slot->type;
+        type = static_cast<srv_thread_type>(slot->type);
 
 	ut_ad(type >= SRV_WORKER);
 	ut_ad(type <= SRV_MASTER);
@@ -1019,15 +1018,15 @@
 	srv_slot_t*		slot;
 	ulint			i;
 
-	srv_sys = mem_alloc(sizeof(srv_sys_t));
+        srv_sys = static_cast<srv_sys_t *>(mem_alloc(sizeof(srv_sys_t)));
 
-	kernel_mutex_temp = mem_alloc(sizeof(mutex_t));
+        kernel_mutex_temp = static_cast<ib_mutex_t *>(mem_alloc(sizeof(mutex_t)));
 	mutex_create(kernel_mutex_key, &kernel_mutex, SYNC_KERNEL);
 
 	mutex_create(srv_innodb_monitor_mutex_key,
 		     &srv_innodb_monitor_mutex, SYNC_NO_ORDER_CHECK);
 
-	srv_sys->threads = mem_alloc(OS_THREAD_MAX_N * sizeof(srv_slot_t));
+        srv_sys->threads = static_cast<srv_table_t *>(mem_alloc(OS_THREAD_MAX_N * sizeof(srv_slot_t)));
 
 	for (i = 0; i < OS_THREAD_MAX_N; i++) {
 		slot = srv_table_get_nth_slot(i);
@@ -1037,7 +1036,7 @@
 		ut_a(slot->event);
 	}
 
-	srv_mysql_table = mem_alloc(OS_THREAD_MAX_N * sizeof(srv_slot_t));
+        srv_mysql_table = static_cast<srv_slot_t *>(mem_alloc(OS_THREAD_MAX_N * sizeof(srv_slot_t)));
 
 	for (i = 0; i < OS_THREAD_MAX_N; i++) {
 		slot = srv_mysql_table + i;
@@ -1079,7 +1078,7 @@
 
 	UT_LIST_INIT(srv_conc_queue);
 
-	srv_conc_slots = mem_alloc(OS_THREAD_MAX_N * sizeof(srv_conc_slot_t));
+        srv_conc_slots = static_cast<srv_conc_slot_t *>(mem_alloc(OS_THREAD_MAX_N * sizeof(srv_conc_slot_t)));
 
 	for (i = 0; i < OS_THREAD_MAX_N; i++) {
 		conc_slot = srv_conc_slots + i;

